--
-- AutoBarProfile
-- Copyright 2006 Toadkiller of Proudmoore.
--
-- Profile System for Autobar
-- http://www.curse-gaming.com/en/wow/addons-4430-1-autobar-toadkiller.html
--

-- Data Structure:
--		AutoBar = {
--			buttons = {AutoBarProfile.basic + AutoBarProfile.CLASS + AutoBar_Config["_SHARED1"].buttons + AutoBar_Config["Toadkiller - Proudmoore"].buttons},
--			display = {AutoBar_Config["Toadkiller - Proudmoore"].display or AutoBar_Config["_SHARED1"].display},
--		};
--		AutoBar_Config["Toadkiller - Proudmoore"] = {
--			buttons = {AutoBarProfile.basic + AutoBarProfile.CLASS + AutoBar_Config["_SHARED1"].buttons},
--			display = {},
--			profile = {},
--		};
--		AutoBar_Config["_SHARED1"] = {
--			buttons = {},
--			display = {},
--		};
--		AutoBarProfile.CLASS
--		AutoBarProfile.basic


AutoBarProfile = {};

local MOUNTSLOT = 2;
local POTIONSLOT = 5;
local BUFFSLOT1 = 7;
local BUFFSLOT2 = 8;
local FOODSLOT = 9;
local BUFFSLOT = 12;
local PETFOOD = 24;

AutoBarProfile.basic = {};
AutoBarProfile.basic[1] = "HEARTHSTONE";
AutoBarProfile.basic[3] = { "BANDAGES", "ALTERAC_BANDAGES", "WARSONG_BANDAGES", "ARATHI_BANDAGES", "UNGORO_RESTORE" };
AutoBarProfile.basic[4] = { "HEALPOTIONS", "REJUVENATION_POTIONS", "WHIPPER_ROOT", "NIGHT_DRAGONS_BREATH", "PVP_HEALPOTIONS", "ALTERAC_HEAL", "HEALTHSTONE" };
AutoBarProfile.basic[6] = { "PROTECTION_ARCANE", "PROTECTION_FROST", "PROTECTION_NATURE", "PROTECTION_SHADOW", "PROTECTION_FIRE", "PROTECTION_SPELLS" };
AutoBarProfile.basic[6].arrangeOnUse = true;
AutoBarProfile.basic[10] = { "FOOD", "FOOD_CONJURED" };
AutoBarProfile.basic[11] = { "FOOD_WATER", "FOOD_ARATHI", "FOOD_WARSONG" };
AutoBarProfile.basic[13] = "SHARPENINGSTONES";
AutoBarProfile.basic[14] = "WEIGHTSTONE";
AutoBarProfile.basic[15] = "SWIFTNESSPOTIONS";
AutoBarProfile.basic[16] = "ACTION_POTIONS";
AutoBarProfile.basic[17] = "EXPLOSIVES";
AutoBarProfile.basic[18] = "FISHINGITEMS";
AutoBarProfile.basic[19] = { "HOURGLASS_SAND", "BATTLE_STANDARD", "BATTLE_STANDARD_AV" };

AutoBarProfile.ROGUE = {};
AutoBarProfile.ROGUE[POTIONSLOT] = "ENERGYPOTIONS";
AutoBarProfile.ROGUE[FOODSLOT] = { "FOOD_STRENGTH", "FOOD_AGILITY", "FOOD_STAMINA", "FOOD_HPREGEN" };
AutoBarProfile.ROGUE[20] = "POISON-MINDNUMBING";
AutoBarProfile.ROGUE[21] = "POISON-WOUND";
AutoBarProfile.ROGUE[22] = "POISON-CRIPPLING";
AutoBarProfile.ROGUE[23] = "POISON-DEADLY";
AutoBarProfile.ROGUE[24] = "POISON-INSTANT";
AutoBarProfile.ROGUE[BUFFSLOT] = { "SCROLL_AGILITY", "SCROLL_PROTECTION", "SCROLL_SPIRIT", "SCROLL_STAMINA", "SCROLL_STRENGTH", "BUFF_ATTACKPOWER", "BUFF_ATTACKSPEED", "BUFF_DODGE", "BUFF_FROST", "BUFF_FIRE", "SCROLL_INTELLECT" };

AutoBarProfile.WARRIOR = {};
AutoBarProfile.WARRIOR[POTIONSLOT] = "RAGEPOTIONS";
AutoBarProfile.WARRIOR[FOODSLOT] = AutoBarProfile.ROGUE[FOODSLOT];
AutoBarProfile.WARRIOR[BUFFSLOT] = AutoBarProfile.ROGUE[BUFFSLOT];

AutoBarProfile.DRUID = {};
AutoBarProfile.DRUID[POTIONSLOT] = { "MANAPOTIONS", "REJUVENATION_POTIONS", "NIGHT_DRAGONS_BREATH", "PVP_MANAPOTIONS", "ALTERAC_MANA" };
AutoBarProfile.DRUID[BUFFSLOT1] = { "WATER", "WATER_CONJURED" };
AutoBarProfile.DRUID[BUFFSLOT2] = "WATER_SPIRIT";
AutoBarProfile.DRUID[FOODSLOT] = { "FOOD_STRENGTH", "FOOD_AGILITY", "FOOD_STAMINA", "FOOD_INTELLIGENCE", "FOOD_HPREGEN", "FOOD_MANAREGEN" };
AutoBarProfile.DRUID[BUFFSLOT] = AutoBarProfile.ROGUE[BUFFSLOT];

AutoBarProfile.HUNTER = {};
AutoBarProfile.HUNTER[POTIONSLOT] = AutoBarProfile.DRUID[POTIONSLOT];
AutoBarProfile.HUNTER[BUFFSLOT1] = AutoBarProfile.DRUID[BUFFSLOT1];
AutoBarProfile.HUNTER[BUFFSLOT2] = AutoBarProfile.DRUID[BUFFSLOT2];
AutoBarProfile.HUNTER[FOODSLOT] = AutoBarProfile.DRUID[FOODSLOT];
AutoBarProfile.HUNTER[PETFOOD] = { "FOOD_PET_BREAD", "FOOD_PET_CHEESE", "FOOD_PET_FISH", "FOOD_PET_FRUIT", "FOOD_PET_FUNGUS", "FOOD_PET_MEAT" };
AutoBarProfile.HUNTER[PETFOOD].arrangeOnUse = true;
AutoBarProfile.HUNTER[PETFOOD].rightClickTargetsPet = true;
AutoBarProfile.HUNTER[BUFFSLOT] = AutoBarProfile.ROGUE[BUFFSLOT];

AutoBarProfile.MAGE = {};
AutoBarProfile.MAGE[POTIONSLOT] = { "MANAPOTIONS", "REJUVENATION_POTIONS", "NIGHT_DRAGONS_BREATH", "PVP_MANAPOTIONS", "ALTERAC_MANA", "MANASTONE" };
AutoBarProfile.MAGE[BUFFSLOT1] = AutoBarProfile.DRUID[BUFFSLOT1];
AutoBarProfile.MAGE[BUFFSLOT2] = AutoBarProfile.DRUID[BUFFSLOT2];
AutoBarProfile.MAGE[FOODSLOT] = { "FOOD_STAMINA", "FOOD_INTELLIGENCE", "FOOD_HPREGEN", "FOOD_MANAREGEN" };
AutoBarProfile.MAGE[BUFFSLOT] = { "SCROLL_AGILITY", "SCROLL_PROTECTION", "SCROLL_SPIRIT", "SCROLL_STAMINA", "SCROLL_STRENGTH", "BUFF_ATTACKPOWER", "BUFF_ATTACKSPEED", "SCROLL_INTELLECT" };

AutoBarProfile.PALADIN = {};
AutoBarProfile.PALADIN[POTIONSLOT] = AutoBarProfile.DRUID[POTIONSLOT];
AutoBarProfile.PALADIN[BUFFSLOT1] = AutoBarProfile.DRUID[BUFFSLOT1];
AutoBarProfile.PALADIN[BUFFSLOT2] = AutoBarProfile.DRUID[BUFFSLOT2];
AutoBarProfile.PALADIN[FOODSLOT] = AutoBarProfile.DRUID[FOODSLOT];
AutoBarProfile.PALADIN[BUFFSLOT] = AutoBarProfile.DRUID[BUFFSLOT];

AutoBarProfile.PRIEST = {};
AutoBarProfile.PRIEST[POTIONSLOT] = AutoBarProfile.DRUID[POTIONSLOT];
AutoBarProfile.PRIEST[BUFFSLOT1] = AutoBarProfile.DRUID[BUFFSLOT1];
AutoBarProfile.PRIEST[BUFFSLOT2] = AutoBarProfile.DRUID[BUFFSLOT2];
AutoBarProfile.PRIEST[FOODSLOT] = AutoBarProfile.MAGE[FOODSLOT];
AutoBarProfile.PRIEST[BUFFSLOT] = AutoBarProfile.MAGE[BUFFSLOT];

AutoBarProfile.SHAMAN = {};
AutoBarProfile.SHAMAN[POTIONSLOT] = AutoBarProfile.DRUID[POTIONSLOT];
AutoBarProfile.SHAMAN[BUFFSLOT1] = AutoBarProfile.DRUID[BUFFSLOT1];
AutoBarProfile.SHAMAN[BUFFSLOT2] = AutoBarProfile.DRUID[BUFFSLOT2];
AutoBarProfile.SHAMAN[FOODSLOT] = AutoBarProfile.DRUID[FOODSLOT];
AutoBarProfile.SHAMAN[BUFFSLOT] = AutoBarProfile.DRUID[BUFFSLOT];

AutoBarProfile.WARLOCK = {};
AutoBarProfile.WARLOCK[POTIONSLOT] = AutoBarProfile.DRUID[POTIONSLOT];
AutoBarProfile.WARLOCK[BUFFSLOT1] = AutoBarProfile.DRUID[BUFFSLOT1];
AutoBarProfile.WARLOCK[BUFFSLOT2] = AutoBarProfile.DRUID[BUFFSLOT2];
AutoBarProfile.WARLOCK[FOODSLOT] = AutoBarProfile.MAGE[FOODSLOT];
AutoBarProfile.WARLOCK[BUFFSLOT] = AutoBarProfile.MAGE[BUFFSLOT];


-- Set up defaults for the player if required
function AutoBarProfile.Initialize()
	if (not AutoBar_Config) then AutoBar_Config = {}; end
	if (not AutoBar_Config[AutoBar.currentPlayer]) then
		AutoBar_Config[AutoBar.currentPlayer] = {};
	end
	for index = 1, 4, 1 do
		local sharedName = "_SHARED"..index;
		if (not AutoBar_Config[sharedName]) then
			AutoBar_Config[sharedName] = {};
		end
		if (not AutoBar_Config[sharedName].buttons) then
			AutoBar_Config[sharedName].buttons = {};
		end
		if (not AutoBar_Config[sharedName].display) then
			AutoBar_Config[sharedName].display = {};
		end
	end
	-- /script DEFAULT_CHAT_FRAME:AddMessage(tostring(AutoBar.currentPlayer))

	-- TODO add versioning & deal with this
	if (AutoBar_Config[AutoBar.currentPlayer].scaling) then
		-- Config is from pre re-write. Not upgrading.
 		AutoBar_Config[AutoBar.currentPlayer] = {};
		AutoBar_Msg(AUTOBAR_CHAT_MESSAGE1);
	end

	if (not AutoBar_Config[AutoBar.currentPlayer].profile) then
		AutoBarProfile:SetDefaults();
	end

	if (not AutoBarProfile.basic[MOUNTSLOT]) then
		-- Mount Slot
		local _, raceEnglish = UnitRace("player");
		if (raceEnglish == "Troll") then
			AutoBarProfile.basic[MOUNTSLOT] = { "MOUNTS_ORC", "MOUNTS_UNDEAD", "MOUNTS_TAUREN", "MOUNTS_TROLL", "MOUNTS_SPECIAL", "MOUNTS_QIRAJI" };
		elseif (raceEnglish == "Orc") then
			AutoBarProfile.basic[MOUNTSLOT] = { "MOUNTS_TROLL", "MOUNTS_UNDEAD", "MOUNTS_TAUREN", "MOUNTS_ORC", "MOUNTS_SPECIAL", "MOUNTS_QIRAJI" };
		elseif (raceEnglish == "Scourge") then
			AutoBarProfile.basic[MOUNTSLOT] = { "MOUNTS_TROLL", "MOUNTS_ORC", "MOUNTS_TAUREN", "MOUNTS_UNDEAD", "MOUNTS_SPECIAL", "MOUNTS_QIRAJI" };
		elseif (raceEnglish == "Tauren") then
			AutoBarProfile.basic[MOUNTSLOT] = { "MOUNTS_TROLL", "MOUNTS_ORC", "MOUNTS_UNDEAD", "MOUNTS_TAUREN", "MOUNTS_SPECIAL", "MOUNTS_QIRAJI" };
		elseif (raceEnglish == "Human") then
			AutoBarProfile.basic[MOUNTSLOT] = { "MOUNTS_NIGHTELF", "MOUNTS_DWARF", "MOUNTS_GNOME", "MOUNTS_HUMAN", "MOUNTS_SPECIAL", "MOUNTS_QIRAJI" };
		elseif (raceEnglish == "NightElf") then
			AutoBarProfile.basic[MOUNTSLOT] = { "MOUNTS_HUMAN", "MOUNTS_DWARF", "MOUNTS_GNOME", "MOUNTS_NIGHTELF", "MOUNTS_SPECIAL", "MOUNTS_QIRAJI" };
		elseif (raceEnglish == "Dwarf") then
			AutoBarProfile.basic[MOUNTSLOT] = { "MOUNTS_HUMAN", "MOUNTS_NIGHTELF", "MOUNTS_GNOME", "MOUNTS_DWARF", "MOUNTS_SPECIAL", "MOUNTS_QIRAJI" };
		elseif (raceEnglish == "Gnome") then
			AutoBarProfile.basic[MOUNTSLOT] = { "MOUNTS_HUMAN", "MOUNTS_NIGHTELF", "MOUNTS_DWARF", "MOUNTS_GNOME", "MOUNTS_SPECIAL", "MOUNTS_QIRAJI" };
		end
		AutoBarProfile.basic[MOUNTSLOT].noPopup = true;
	end

	if (not AutoBar_Config[AutoBar.currentPlayer].buttons) then
		AutoBar_Config[AutoBar.currentPlayer].buttons = {};
	end

	if (not AutoBar.buttons) then
		AutoBarProfile:ButtonsCopy();
	end

	-- Also update display defaults if needed
	if (not AutoBar_Config[AutoBar.currentPlayer].display) then
		AutoBar_Config[AutoBar.currentPlayer].display = {};
		AutoBarProfile:DisplayCopy();
	end

	if (not AutoBar.display) then
		AutoBarProfile:DisplayCopy();
	end
end


function AutoBarProfile:SetDefaults()
	AutoBar_Config[AutoBar.currentPlayer].profile = {};
	AutoBar_Config[AutoBar.currentPlayer].profile.useCharacter = false;
	AutoBar_Config[AutoBar.currentPlayer].profile.useShared = true;
	AutoBar_Config[AutoBar.currentPlayer].profile.useClass = true;
	AutoBar_Config[AutoBar.currentPlayer].profile.useBasic = true;
	AutoBar_Config[AutoBar.currentPlayer].profile.layout = AutoBarConfigCheckboxes["layout"].default;
	AutoBar_Config[AutoBar.currentPlayer].profile.editing = "_SHARED1";
	AutoBar_Config[AutoBar.currentPlayer].profile.shared = "_SHARED1";
	-- TODO dropdown to pick shared
end


function AutoBarProfile:ProfileChanged()
	AutoBarProfile:DisplayCopy();
	AutoBarProfile:ButtonsCopy();
	AutoBar.ConfigChanged();
end


function AutoBarProfile:DisplayChanged()
	AutoBarProfile:DisplayCopy();
	AutoBar.ConfigChanged();
end


function AutoBarProfile:ButtonsChanged()
--DEFAULT_CHAT_FRAME:AddMessage("AutoBarProfile:ButtonsChanged");
	AutoBarProfile:ButtonsCopy();
	AutoBar.ConfigChanged();
	AutoBar_SetupVisual();
	AutoBarConfig:SlotsViewInitialize();
	AutoBarConfig:SlotsInitialize();
end


function AutoBarProfile:DisplayCopy()
	local profile = AutoBar_Config[AutoBar.currentPlayer].profile;

	AutoBar.display = nil;
	if (AutoBar_Config[AutoBar.currentPlayer].profile.layout == 1) then
		AutoBar.display = AutoBar_Config[AutoBar.currentPlayer].display;
	else
		AutoBar.display = AutoBar_Config[profile.shared].display;
	end
end


-- Assign buttons from eligible layer with precedence characterButtons > sharedButtons > classButtons > basicButtons
function AutoBarProfile:ButtonsCopy()
	local _, class = UnitClass("player");

	local profile = AutoBar_Config[AutoBar.currentPlayer].profile;
	local characterButtons, sharedButtons, classButtons, basicButtons;

	if (profile.useCharacter and AutoBar_Config[AutoBar.currentPlayer].buttons) then
		characterButtons = AutoBar_Config[AutoBar.currentPlayer].buttons;
	end
	if (profile.useShared and profile.shared and AutoBar_Config[profile.shared] and AutoBar_Config[profile.shared].buttons) then
		sharedButtons = AutoBar_Config[profile.shared].buttons;
	end
	if (profile.useClass and class and AutoBarProfile[class]) then
		classButtons = AutoBarProfile[class];
	end
	if (profile.useBasic and AutoBarProfile.basic) then
		basicButtons = AutoBarProfile.basic;
	end

	-- Copy the buttons
	if (not AutoBar.buttons) then
		AutoBar.buttons = {};
	end
	for buttonIndex = 1, AUTOBAR_MAXBUTTONS, 1 do
		if (characterButtons and characterButtons[buttonIndex]) then
			AutoBar.buttons[buttonIndex] = characterButtons[buttonIndex];
		elseif (sharedButtons and sharedButtons[buttonIndex]) then
			AutoBar.buttons[buttonIndex] = sharedButtons[buttonIndex];
		elseif (classButtons and classButtons[buttonIndex]) then
			AutoBar.buttons[buttonIndex] = classButtons[buttonIndex];
		elseif (basicButtons and basicButtons[buttonIndex]) then
			AutoBar.buttons[buttonIndex] = basicButtons[buttonIndex];
		else
			AutoBar.buttons[buttonIndex] = nil;
		end
	end

	-- Copy the SmartCast info.
	-- This is imperfect as an absense in a table can not overide a presence.
	-- TODO: dump single item slots & fold smartSelfcast into buttons.
	AutoBar.smartSelfcast = {};
	-- Basic and class are already combined
	if (profile.useBasic and AutoBarProfile.smartSelfcast) then
		for category in AutoBarProfile.smartSelfcast do
			if (not AutoBar.smartSelfcast[category]) then
				table.insert(AutoBar.smartSelfcast, category);
			end
		end
	end
	if (profile.useShared and profile.shared and AutoBar_Config[profile.shared] and AutoBar_Config[profile.shared].smartSelfcast) then
		for category in AutoBar_Config[profile.shared].smartSelfcast do
			if (not AutoBar.smartSelfcast[category]) then
				table.insert(AutoBar.smartSelfcast, category);
			end
		end
	end
	if (profile.useCharacter and AutoBar_Config[AutoBar.currentPlayer].smartSelfcast) then
		for category in AutoBar_Config[AutoBar.currentPlayer].smartSelfcast do
			if (not AutoBar.smartSelfcast[category]) then
				table.insert(AutoBar.smartSelfcast, category);
			end
		end
	end
	if (table.getn(AutoBar.smartSelfcast) == 0) then
		AutoBar.smartSelfcast = nil;
	end
end
